# Tests by default. No tests: rpm -ba --define 'dotests 0' *.spec
%{!?dotests: %define dotests 1}

%define soname 25.5.0 
%define _libdir64 %{_prefix}/lib64

#################################
#  End of user-modifiable configs
#################################
%define name protobuf
%define version	4.25.5
%define release	1
%define javadir %{_prefix}/java
%define libdir64 %{_prefix}/lib64

#python releated configs
%global py_major	3.9
%global py_minor 16

%global python_major python%{py_major}

%global python3_sitearch %(%{python_major} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(0))")
%global python3_sitearch64 %(%{python_major} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")

Summary:    Protocol Buffers - Google's data interchange format
Name:       %{name}
Version:    %{version}
Release:    %{release}
License:    BSD
Group:      Development/Libraries/C and C++
URL:        https://github.com/protocolbuffers/protobuf
Source0:	https://github.com/protocolbuffers/protobuf/archive/refs/tags/v%{version}.tar.gz
Source1:    ftdetect-proto.vim
Source2:    protobuf-init.el
Source5:    manifest.txt.in
Source6:    libprotobuf.so.22-aix64
Source7:    libprotobuf-lite.so.22-aix64
Source8:    libprotoc.so.22-aix64
Source9:    libprotobuf.so.30-aix64
Source10:   libprotobuf-lite.so.30-aix64
Source11:   libprotoc.so.30-aix64
Source12:   libprotobuf.so.31-aix64
Source13:   libprotobuf-lite.so.31-aix64
Source14:   libprotoc.so.31-aix64
Source15:   libprotobuf.so.23.4.0-aix64
Source16:   libprotobuf-lite.so.23.4.0-aix64
Source17:   libprotoc.so.23.4.0-aix64

#somehow, 32 bit version of .so.22 is lost, So it will not be part of archive.
Source50:    libprotobuf.so.30-aix32
Source51:    libprotobuf-lite.so.30-aix32
Source52:    libprotoc.so.30-aix32
Source53:    libprotobuf.so.31-aix32
Source54:    libprotobuf-lite.so.31-aix32
Source55:    libprotoc.so.31-aix32
Source56:    libprotobuf.so.23.4.0-aix32
Source57:    libprotobuf-lite.so.23.4.0-aix32
Source58:    libprotoc.so.23.4.0-aix32

Patch1:	%{name}-2.5.0-atomicops_internals_aix.h.patch
Patch3: protobuf-4.25.5-port_def.patch
Patch4: protobuf-4.23.4-zero_copy_stream_unittest.patch

BuildRequires:	zlib-devel >= 1.2.13
BuildRequires:  %{python_major}-devel >= %{py_major}.%{py_minor}
BuildRequires:  %{python_major}-setuptools >= 65.2.0

# Test while build GCC running with 1.11 BuildRequires:  automake >= 1.14
BuildRequires:	automake >= 1.16.5
#BuildRequires:	emacs >= 29.1
%if %{toolchain} == "gcc"
BuildRequires:	libgcc >= 10.3.0
%endif
BuildRequires:	libstdc++-devel >= 10.3.0
BuildRequires:	gmock-devel >= 1.15.2
BuildRequires:	gtest-devel >= 1.15.2
BuildRequires:	abseil-cpp-devel >= 20240722.0
 
%if %{toolchain} == "gcc"
Requires:	libstdc++ >= 10.3.0
%endif
%if %{toolchain} == "gcc"
Requires:	libgcc >= 10.3.0
%endif
Requires:	zlib >= 1.2.13
Requires:	abseil-cpp >= 20240722.0

%description
Protocol Buffers are a way of encoding structured data in an efficient yet
extensible format. Google uses Protocol Buffers for almost all of its internal
RPC protocols and file formats. 

# package libprotoc - This RPM is named protobuf-compiler on Fedora
%package compiler
Summary:        Protocol Buffers compiler
Group:          System/Libraries
%if %{toolchain} == "gcc"
Requires:	libstdc++ >= 10.3.0
%endif
%if %{toolchain} == "gcc"
Requires:	libgcc >= 10.3.0
%endif
Requires:       protobuf = %{version}-%{release}
Obsoletes:      %{name}-libprotoc

# description libprotoc
%description compiler
This package contains Protocol Buffers compiler for all programming
languages.

%package lite
Summary:        Protocol Buffers LITE_RUNTIME libraries
Group:          System/Libraries
%if %{toolchain} == "gcc"
Requires:	libstdc++ >= 10.3.0
%endif
%if %{toolchain} == "gcc"
Requires:	libgcc >= 10.3.0
%endif
Requires:	abseil-cpp >= 20240722.0

%description lite
Protocol Buffers built with optimize_for = LITE_RUNTIME.

The LITE_RUNTIME option causes the compiler to generate code which only
depends on libprotobuf-lite, which is much smaller than libprotobuf but
lacks descriptors, reflection, and some other features.

%package devel
Summary:        Header files, libraries and development documentation for %{name}
Group:          Development/Libraries/C and C++

Requires:       protobuf = %{version}-%{release}
Requires:       protobuf-compiler = %{version}-%{release}
Requires:	zlib-devel >= 1.2.13
Requires:	abseil-cpp-devel >= 20240722.0

%description devel
Development files for Google Protocol Buffers.
This includes the Protocol Buffers compiler for all languages and
C++ headers and libraries.

%package python3
Requires:       %{python_major} >= %{py_major}.%{py_minor}
Summary:        Python 3 bindings for Google Protocol Buffers
Group:          Development/Libraries/Python

BuildRequires:  %{python_major}-devel >= %{py_major}.%{py_minor}
BuildRequires:  %{python_major}-setuptools >= 65.2.0
Requires:       %{python_major}-six >= 1.13.0
Requires:       protobuf = %{version}-%{release}
Conflicts:      %{name}-compiler > %{version}
Conflicts:      %{name}-compiler < %{version}

%description python3
This package contains the Python 3 bindings for Google Protocol Buffers.

%prep
%setup -q 

%patch1 -p1
%patch3 -p1
%patch4 -p1

rm -rf   /tmp/%{name}-%{version}-32bit
cp -pr . /tmp/%{name}-%{version}-32bit
rm -fr *
mv       /tmp/%{name}-%{version}-32bit 32bit
cp -pr 32bit 64bit


%build
export RM="/usr/bin/rm -f"
export CONFIG_SHELL=/opt/freeware/bin/bash
export CONFIG_ENV_ARGS=/opt/freeware/bin/bash
export AR="ar -X32_64"
export NM="nm -X32_64"
export PTHREAD_LIBS=-lpthread
export PATCH=/opt/freeware/bin/patch
export PROTOCOL_BUFFERS_PYTHON_IMPLEMENTATION=cpp
export PROTOCOL_BUFFERS_PYTHON_IMPLEMENTATION_VERSION=2

# Building 64 bit version
cd 64bit

export CC="%{__cc__} "
export CXX="%{__cxx__} "
export OBJECT_MODE=64
export CFLAGS="-maix64 -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CXXFLAGS="-maix64 -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CPPFLAGS="-I`pwd`/include -I/opt/freeware/include -I/usr/include"
export LDFLAGS="-Wl,-bbigtoc -lcrypt -L/opt/freeware/lib/pthread -L/opt/freeware/lib64 -L/opt/freeware/lib -L/usr/lib"

#C/C++ bins/libs building
cmake . -B build  \
	-Dprotobuf_ABSL_PROVIDER=package \
	-DCMAKE_POSITION_INDEPENDENT_CODE=ON \
	-Dprotobuf_BUILD_LIBPROTOC=ON \
	-DBUILD_SHARED_LIBS=ON \
	-Dprotobuf_USE_EXTERNAL_GTEST=ON \
	-DCMAKE_INSTALL_LIBDIR=lib64 \
        -DCMAKE_AIX_SHARED_LIBRARY_ARCHIVE=ON \
	-DCMAKE_INSTALL_PREFIX=%{_prefix}

cmake --build build -j4

#python binding building
cp -r python python3
cd python3
TEMPPATH=$PATH
export PATH=%{_builddir}/%{name}-%{version}/64bit/build:$PATH
LIBPATH=`pwd`/../build:/opt/freeware/lib/pthread:/opt/freeware/lib64 %{python_major} setup.py build
export PATH=$TEMPPATH
cd ..

# Building 32 bit version
cd ../32bit

export CC="%{__cc__} "
export CXX="%{__cxx__} "
export OBJECT_MODE=32
export CFLAGS="-maix32 -D_LARGE_FILES -pthread -O2  -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CXXFLAGS="-maix32 -D_LARGE_FILES -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CPPFLAGS="-I`pwd`/include -I/opt/freeware/include -I/usr/include"
export LDFLAGS="-Wl,-bbigtoc -lcrypt -latomic -L/opt/freeware/lib/pthread -L/opt/freeware/lib -L/usr/lib" 

#C/C++ bins/libs building
cmake . -B build \
        -Dprotobuf_ABSL_PROVIDER=package \
        -DCMAKE_POSITION_INDEPENDENT_CODE=ON \
        -Dprotobuf_BUILD_LIBPROTOC=ON \
        -DBUILD_SHARED_LIBS=ON \
        -Dprotobuf_USE_EXTERNAL_GTEST=ON \
        -DCMAKE_INSTALL_LIBDIR=lib \
        -DCMAKE_AIX_SHARED_LIBRARY_ARCHIVE=ON \
        -DCMAKE_INSTALL_PREFIX=%{_prefix}

cmake --build build -j4

#python binding building
cp -r python python3
cd python3
TEMPPATH=$PATH
export PATH=%{_builddir}/%{name}-%{version}/32bit/build:$PATH
LIBPATH=`pwd`/../build:/opt/freeware/lib/pthread:/opt/freeware/lib /opt/freeware/libexec/python3.9_32 setup.py build
export PATH=$TEMPPATH
cd ..

%install
export PROTOCOL_BUFFERS_PYTHON_IMPLEMENTATION=cpp
export PROTOCOL_BUFFERS_PYTHON_IMPLEMENTATION_VERSION=2

echo "RPM_BUILD_ROOT: $RPM_BUILD_ROOT"
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

#For python libraries to build, need linking for abseil-cpp libraries.
ABSEIL_CPP_LIBS="-labsl_die_if_null -labsl_log_initialize -labsl_statusor -labsl_log_internal_check_op -labsl_leak_check -labsl_log_internal_conditions  -labsl_log_internal_message -labsl_log_internal_nullguard -labsl_examine_stack  -labsl_log_internal_format  -labsl_log_internal_proto -labsl_log_internal_log_sink_set  -labsl_log_sink -labsl_log_entry  -labsl_flags_internal -labsl_flags_marshalling -labsl_flags_reflection  -labsl_flags_config  -labsl_flags_program_name  -labsl_flags_private_handle_accessor  -labsl_flags_commandlineflag  -labsl_flags_commandlineflag_internal -labsl_log_globals  -labsl_log_internal_globals -labsl_raw_hash_set  -labsl_hash -labsl_city -labsl_low_level_hash -labsl_hashtablez_sampler -labsl_status -labsl_cord -labsl_cordz_info -labsl_cord_internal -labsl_cordz_functions -labsl_exponential_biased -labsl_cordz_handle -labsl_synchronization -labsl_graphcycles_internal -labsl_kernel_timeout_internal -labsl_time -labsl_civil_time -labsl_time_zone -labsl_crc_cord_state -labsl_crc32c -labsl_crc_internal -labsl_crc_cpu_detect -labsl_bad_optional_access -labsl_stacktrace -labsl_str_format_internal -labsl_strerror -labsl_symbolize -labsl_malloc_internal -labsl_debugging_internal -labsl_demangle_internal -labsl_bad_variant_access -labsl_strings -labsl_int128 -labsl_string_view -labsl_throw_delegate -labsl_strings_internal -labsl_base -labsl_raw_logging_internal -labsl_log_severity -labsl_spinlock_wait"

#Install 32bit
cd 32bit
export CC="%{__cc__} "
export CXX="%{__cxx__} "
export OBJECT_MODE=32
export CFLAGS="-maix32 -D_LARGE_FILES -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CXXFLAGS="-maix32 -D_LARGE_FILES -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CPPFLAGS="-I`pwd`/include -I/opt/freeware/include -I/usr/include"
export LDFLAGS="-Wl,-bbigtoc -L%{_builddir}/%{name}-%{version}/32bit/build -L/opt/freeware/lib/pthread -L/opt/freeware/lib -L/usr/lib -lcrypt -latomic $ABSEIL_CPP_LIBS"

#install C/C++ bins/libs
export DESTDIR=$RPM_BUILD_ROOT
cmake --install build
mv $RPM_BUILD_ROOT%{_prefix}/bin/protoc-%{soname} $RPM_BUILD_ROOT%{_prefix}/bin/protoc_32
rm $RPM_BUILD_ROOT%{_prefix}/bin/protoc
/usr/bin/strip -X32 $RPM_BUILD_ROOT%{_prefix}/bin/protoc_32

# install python3
cd python3
LIBPATH=`pwd`/../build:/opt/freeware/lib/pthread:/opt/freeware/lib /opt/freeware/libexec/python3.9_32 setup.py install --cpp_implementation\
        --prefix=%{_prefix} \
        --install-data=$RPM_BUILD_ROOT \
        --root  $RPM_BUILD_ROOT \
        --record=INSTALLED_FILES
cd ..

#Archive older libraries
(
#64 bit libraries
cd ${RPM_BUILD_ROOT}%{_libdir}
cp %{SOURCE6} libprotobuf.so.22
/usr/bin/strip -X64 -e libprotobuf.so.22
/usr/bin/ar -X64 -q libprotobuf.a libprotobuf.so.22
cp %{SOURCE7} libprotobuf-lite.so.22
/usr/bin/strip -X64 -e libprotobuf-lite.so.22
/usr/bin/ar -X64 -q libprotobuf-lite.a libprotobuf-lite.so.22
cp %{SOURCE8} libprotoc.so.22
/usr/bin/strip -X64 -e libprotoc.so.22
/usr/bin/ar -X64 -q libprotoc.a libprotoc.so.22

cp %{SOURCE9} libprotobuf.so.30
/usr/bin/strip -X64 -e libprotobuf.so.30
/usr/bin/ar -X64 -q libprotobuf.a libprotobuf.so.30
cp %{SOURCE10} libprotobuf-lite.so.30
/usr/bin/strip -X64 -e libprotobuf-lite.so.30
/usr/bin/ar -X64 -q libprotobuf-lite.a libprotobuf-lite.so.30
cp %{SOURCE11} libprotoc.so.30
/usr/bin/strip -X64 -e libprotoc.so.30
/usr/bin/ar -X64 -q libprotoc.a libprotoc.so.30

cp %{SOURCE12} libprotobuf.so.31
/usr/bin/strip -X64 -e libprotobuf.so.31
/usr/bin/ar -X64 -q libprotobuf.a libprotobuf.so.31
cp %{SOURCE13} libprotobuf-lite.so.31
/usr/bin/strip -X64 -e libprotobuf-lite.so.31
/usr/bin/ar -X64 -q libprotobuf-lite.a libprotobuf-lite.so.31
cp %{SOURCE14} libprotoc.so.31
/usr/bin/strip -X64 -e libprotoc.so.31
/usr/bin/ar -X64 -q libprotoc.a libprotoc.so.31

cp %{SOURCE15} libprotobuf.so.23.4.0
/usr/bin/strip -X64 -e libprotobuf.so.23.4.0
/usr/bin/ar -X64 -q libprotobuf.a libprotobuf.so.23.4.0
cp %{SOURCE16} libprotobuf-lite.so.23.4.0
/usr/bin/strip -X64 -e libprotobuf-lite.so.23.4.0
/usr/bin/ar -X64 -q libprotobuf-lite.a libprotobuf-lite.so.23.4.0
cp %{SOURCE17} libprotoc.so.23.4.0
/usr/bin/strip -X64 -e libprotoc.so.23.4.0
/usr/bin/ar -X64 -q libprotoc.a libprotoc.so.23.4.0

#32 bit libraries
cp %{SOURCE50} libprotobuf.so.30
/usr/bin/strip -X32 -e libprotobuf.so.30
/usr/bin/ar -X32 -q libprotobuf.a libprotobuf.so.30
cp %{SOURCE51} libprotobuf-lite.so.30
/usr/bin/strip -X32 -e libprotobuf-lite.so.30
/usr/bin/ar -X32 -q libprotobuf-lite.a libprotobuf-lite.so.30
cp %{SOURCE52} libprotoc.so.30
/usr/bin/strip -X32 -e libprotoc.so.30
/usr/bin/ar -X32 -q libprotoc.a libprotoc.so.30


cp %{SOURCE53} libprotobuf.so.31
/usr/bin/strip -X32 -e libprotobuf.so.31
/usr/bin/ar -X32 -q libprotobuf.a libprotobuf.so.31
cp %{SOURCE54} libprotobuf-lite.so.31
/usr/bin/strip -X32 -e libprotobuf-lite.so.31
/usr/bin/ar -X32 -q libprotobuf-lite.a libprotobuf-lite.so.31
cp %{SOURCE55} libprotoc.so.31
/usr/bin/strip -X32 -e libprotoc.so.31
/usr/bin/ar -X32 -q libprotoc.a libprotoc.so.31


cp %{SOURCE56} libprotobuf.so.23.4.0
/usr/bin/strip -X32 -e libprotobuf.so.23.4.0
/usr/bin/ar -X32 -q libprotobuf.a libprotobuf.so.23.4.0
cp %{SOURCE57} libprotobuf-lite.so.23.4.0
/usr/bin/strip -X32 -e libprotobuf-lite.so.23.4.0
/usr/bin/ar -X32 -q libprotobuf-lite.a libprotobuf-lite.so.23.4.0
cp %{SOURCE58} libprotoc.so.23.4.0
/usr/bin/strip -X32 -e libprotoc.so.23.4.0
/usr/bin/ar -X32 -q libprotoc.a libprotoc.so.23.4.0
)

#Install 64bit
cd ../64bit

export CC="%{__cc__}"
export CXX="%{__cxx__}"
export OBJECT_MODE=64
export CFLAGS="-maix64 -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CXXFLAGS="-maix64 -pthread -O2 -fPIC -I`pwd`/include -I/opt/freeware/include -I/usr/include"
export CPPFLAGS="-I`pwd`/include -I/opt/freeware/include -I/usr/include"
export LDFLAGS="-Wl,-bbigtoc -L%{_builddir}/%{name}-%{version}/64bit/build -L/opt/freeware/lib/pthread -L/opt/freeware/lib64 -L/opt/freeware/lib -L/usr/lib -lcrypt $ABSEIL_CPP_LIBS"


#install C/C++ bins/libs
export DESTDIR=$RPM_BUILD_ROOT
cmake --install build
mv $RPM_BUILD_ROOT%{_prefix}/bin/protoc-%{soname} $RPM_BUILD_ROOT%{_prefix}/bin/protoc_64
rm $RPM_BUILD_ROOT%{_prefix}/bin/protoc
/usr/bin/strip -X64 $RPM_BUILD_ROOT%{_prefix}/bin/protoc_64
cd $RPM_BUILD_ROOT%{_prefix}/bin
ln -sf protoc_64 protoc
ln -sf protoc protoc-%{soname} 

cd %{buildroot}%{_libdir64}/
PROTOBUF_LIBS="libprotobuf libprotoc libprotobuf-lite"
for file in $PROTOBUF_LIBS
do
        /usr/bin/ar -X64 -xv $file.a
        /usr/bin/ar -X64 -q %{buildroot}%{_libdir}/$file.a  $file.so.%{soname}
done
cd -

cd $RPM_BUILD_ROOT%{_prefix}/lib64
rm  libprotobuf.a libprotoc.a libprotobuf-lite.a 
ln -s ../lib/libprotobuf.a libprotobuf.a
ln -s ../lib/libprotoc.a libprotoc.a
ln -s ../lib/libprotobuf-lite.a libprotobuf-lite.a
cd -

# install python3
cd %{_builddir}/%{name}-%{version}/64bit/python3
LIBPATH=`pwd`/../build:/opt/freeware/lib/pthread:/opt/freeware/lib64 %{python_major} setup.py install --cpp_implementation \
        --prefix=%{_prefix} \
        --install-data=$RPM_BUILD_ROOT \
        --root  $RPM_BUILD_ROOT \
        --record=INSTALLED_FILES

%check
#https://github.com/protocolbuffers/protobuf/issues/8082  --> for blocking IoTest.LargeOutput
cd 64bit/build
./lite-test -V
./tests -V --gtest_filter=*-AnyTest.TestPackFromSerializationExceedsSizeLimit:IoTest.BlockingFileIoWithTimeout:CommandLineInterfaceTest.DescriptorSetOptionRetention* || true
cd ../../32bit/build
./lite-test -V
./tests -V --gtest_filter=*-AnyTest.TestPackFromSerializationExceedsSizeLimit:MessageTest.TestParseMessagesCloseTo2G:MessageTest.TestParseMessagesOver2G:IoTest.BlockingFileIoWithTimeout:CommandLineInterfaceTest.DescriptorSetOptionRetention* || true

%files
%defattr(-, root, system,-)
%doc 32bit/LICENSE
%doc 32bit/CONTRIBUTORS.txt 32bit/README.md
%{_libdir64}/libprotobuf.a
%{_libdir64}/libutf8_range.a
%{_libdir64}/libutf8_validity.a
%{_libdir}/libprotobuf.a
%{_libdir}/libutf8_range.a
%{_libdir}/libutf8_validity.a

%files compiler
%defattr(-, root, system,-)
%doc 32bit/LICENSE
%doc 32bit/CONTRIBUTORS.txt 32bit/README.md
%{_bindir}/protoc*
%{_libdir64}/libprotoc.a
%{_libdir}/libprotoc.a

%files lite
%defattr(-, root, system,-)
%doc 32bit/LICENSE
%doc 32bit/CONTRIBUTORS.txt 32bit/README.md
%{_libdir64}/libprotobuf-lite.a
%{_libdir64}/libutf8_range.a
%{_libdir64}/libutf8_validity.a
%{_libdir}/libprotobuf-lite.a
%{_libdir}/libutf8_range.a
%{_libdir}/libutf8_validity.a

%files devel
%defattr(-,root,system,-)
%doc 32bit/LICENSE
%doc 32bit/CONTRIBUTORS.txt 32bit/README.md
%doc 32bit/examples/add_person.cc 32bit/examples/addressbook.proto
%doc 32bit/examples/list_people.cc 32bit/examples/Makefile
%doc 32bit/examples/README.md
%{_includedir}/google/protobuf
%{_includedir}/*.h
%{_libdir64}/pkgconfig/protobuf.pc
%{_libdir64}/cmake/protobuf
%{_libdir64}/cmake/utf8_range
%{_libdir}/pkgconfig/protobuf.pc
%{_libdir}/cmake/protobuf
%{_libdir}/cmake/utf8_range

# python3
#%files -n python-%{name} -f python/INSTALLED_FILES
%files python3
%defattr(-,root,system,-)
%doc 32bit/LICENSE
%doc 32bit/CONTRIBUTORS.txt 32bit/python3/README.md
%doc 32bit/examples/add_person.py 32bit/examples/list_people.py 32bit/examples/addressbook.proto
%{python3_sitearch64}/*
%{python3_sitearch}/*

%changelog
* Fri Oct 18 2024 Ranjit Ranjan <ranjit.ranjan@ibm.com> - 4.25.5-1 
- Update to version 4.25.5 contains CVE-2024-2410 fix.

* Thu Aug 24 2023 Ranjit Ranjan<ranjit.ranjan@ibm.com> - 4.23.4-1
- Update to 4.23.4.

* Thu Jun 08 2023 Ranjit Ranjan<ranjit.ranjan@ibm.com> - 3.20.2-1
- Update to 3.20.2.

* Mon Apr 03 2023 Ranjit Ranjan<ranjit.ranjan@ibm.com> - 3.19.6-2
- Update to build with python 3.9.

* Tue Dec 06 2022 Reshma V Kumar <reskumar@in.ibm.com> - 3.19.6-1
- Update to fix CVE-2022-3171,CVE-2022-1941

* Wed Mar 02 2022 Reshma V Kumar <reskumar@in.ibm.com> - 3.19.4-1
- Update to fix CVE-2021-22569

* Fri Nov 05 2021 Rishita Saha <risaha16@in.ibm.com> - 3.19.1-1
- Update to latest version

* Thu Mar 19 2020 Ashwini Chandrappa<ashwic22@in.ibm.com> - 3.11.4-1
- Initial port to AIX Toolbox
- Updated to 3.11.4

* Fri Feb 08 2019 Michael Wilson <michael.a.wilson@atos.net> - 3.6.1-1
- Update to version 3.6.1
- Largely inspired by Fedora 30
- Add option -pthread for c++  mutex/pthreads support, e.g.
-          export CXX="g++ -maix64 -pthread"
- Add link with libatomic.a for 32 bit build for symbol __atomic_fetch_add_8
- Change LDFLAGS for %install to same as %build for pthread symbols __once_*
-          to find pthread/libstcc++.a  before non-pthread version
-          -L:/opt/freeware/lib/pthread (a W/A for libtool issue)
- Also add /opt/freeware/lib/pthread to head of -blibpath in libtool
-          so bin/protoc executes with pthread g++ libs
- New java code requires use of Java7 javac (LPP Java7.sdk)
- Change hard coded soname 8 to %{soname}  for the AR commands

* Thu Jun 7 2018 by Tony Reix <tony.reix@atos.net> 2.5.0-2
- Re-Port on AIX 6.1 
- Add atomicops_internals_aix.h moved to AIX assembler
- Fix 32bit/64bit management

* Fri May 3 2013 by Bernard CAHEN <bernard.cahen@bull.net> 2.4.1-1
- Port on AIX 6.1 
